<?php

declare(strict_types=1);

namespace App\Model;



/**
 * @property int $id 
 * @property string $name 
 * @property string $cn_name 
 * @property string $first_letter 
 * @property string $logo 
 * @property string $description 
 * @property int $is_del 
 * @property \Carbon\Carbon $created_at 
 * @property \Carbon\Carbon $updated_at 
 * @property int $created_by 
 * @property int $updated_by 
 * @property string $spider_origin 
 */
class AppBrand extends Model
{
    /**
     * The table associated with the model.
     */
    protected ?string $table = 'app_brands';

    /**
     * The attributes that are mass assignable.
     */
    protected array $fillable = [];

    /**
     * The attributes that should be cast to native types.
     */
    protected array $casts = ['id' => 'integer', 'is_del' => 'integer', 'created_at' => 'datetime', 'updated_at' => 'datetime', 'created_by' => 'integer', 'updated_by' => 'integer'];

    protected ?string $dateFormat = 'U';
}
